##==============================================================================
##
##	crt0.S
##
##	nds32 startup code
##
##==============================================================================
##
## Copyright (c) 1995, 1996, 1997, 1998 Cygnus Solutions
## 
## The authors hereby grant permission to use, copy, modify, distribute,
## and license this software and its documentation for any purpose, provided
## that existing copyright notices are retained in all copies and that this
## notice is included verbatim in any distributions. No written agreement,
## license, or royalty fee is required for any of the authorized uses.
## Modifications to this software may be copyrighted by their authors
## and need not follow the licensing terms described here, provided that
## the new terms are clearly indicated on the first page of each file where
## they apply.
##
	
#define PSW_kbfINTL	  (0x3<<1)
#include "config.h"
#include "interrupt.h"
##------------------------------------------------------------------------------
	
	.file	"crt0.S"

##------------------------------------------------------------------------------
##      For N1003 Board without elfloader, We must have a section whcih can point-out the binary start
##------------------------------------------------------------------------------
	.section .nds32_init, "ax"
exception_vector:
        		j _start
        .macro EXCEPTION_VECTOR handler
#if (VECTOR_SIZE==4)
				j	handler
#else
        .align 4
                push    $a0
                sethi   $a0, hi20(\handler)
                ori     $a0, $a0, lo12(\handler)
                jral    $a0, $a0
#endif
        .endm

!========================================================================
! Vector table
!========================================================================

        !(0) Trap Reset/NMI
#if (VECTOR_SIZE==16)
		sethi             $r0, hi20(OS_Trap_Reset)
		ori               $r0, $r0, lo12(OS_Trap_Reset)
		jral              $r0, $r0
#endif
        EXCEPTION_VECTOR  OS_Trap_TLB_Fill                !  (1) Trap TLB fill
        EXCEPTION_VECTOR  OS_Trap_PTE_Not_Present         !  (2) Trap PTE not present
        EXCEPTION_VECTOR  OS_Trap_TLB_Misc                !  (3) Trap TLB misc
        EXCEPTION_VECTOR  OS_Trap_TLB_VLPT_Miss           !  (4) Trap TLB VLPT miss
        EXCEPTION_VECTOR  OS_Trap_Machine_Error           !  (5) Trap Machine error
        EXCEPTION_VECTOR  OS_Trap_Debug_Related           !  (6) Trap Debug related
        EXCEPTION_VECTOR  OS_Trap_General_Exception       !  (7) Trap General exception
        EXCEPTION_VECTOR  OS_Trap_Syscall                 !  (8) Syscall
        EXCEPTION_VECTOR  OS_Trap_Interrupt_HW0           !  (9) Interrupt HW0
        EXCEPTION_VECTOR  OS_Trap_Interrupt_HW1           ! (10) Interrupt HW1
        EXCEPTION_VECTOR  OS_Trap_Interrupt_HW2           ! (11) Interrupt HW2
        EXCEPTION_VECTOR  OS_Trap_Interrupt_HW3           ! (12) Interrupt HW3
        EXCEPTION_VECTOR  OS_Trap_Interrupt_HW4           ! (13) Interrupt HW4
        EXCEPTION_VECTOR  OS_Trap_Interrupt_HW5           ! (14) Interrupt HW5
        EXCEPTION_VECTOR  OS_Trap_SWI                     ! (15) Interrupt SW0
exception_vector_end:

/*
 * exception handlers
 */
OS_Trap_Reset:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SAVE_ALL
		li	$r0, 0x00
		b       common_exception_handler

OS_Trap_TLB_Fill:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SAVE_ALL
    	li      $r0, 0x01
        b       common_exception_handler

OS_Trap_PTE_Not_Present:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SAVE_ALL
        li      $r0, 0x02
        b       common_exception_handler

OS_Trap_TLB_Misc:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SAVE_ALL
        li      $r0, 0x03
        b       common_exception_handler

OS_Trap_TLB_VLPT_Miss:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SAVE_ALL
        li      $r0, 0x04
        b       common_exception_handler

OS_Trap_Machine_Error:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SAVE_ALL
        li      $r0, 0x05
        b       common_exception_handler

OS_Trap_Debug_Related:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SAVE_ALL
        li      $r0, 0x06
        b       common_exception_handler

OS_Trap_General_Exception:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SAVE_ALL
        li      $r0, 0x07
        b       common_exception_handler

OS_Trap_Syscall:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SYSCALL_SAVE_ALL
        /*bal	syscall_handler*/
		gie_disable
		SYSCALL_RESTORE_ALL
		iret


OS_Trap_Interrupt_HW0:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SAVE_ALL
        li      $r0, 0x09
        b       common_exception_handler

OS_Trap_Interrupt_HW1:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SAVE_ALL
        li      $r0, 0x0a
        b       common_exception_handler

OS_Trap_Interrupt_HW2:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SAVE_ALL
        li      $r0, 0x0b
        b       common_exception_handler

OS_Trap_Interrupt_HW3:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SAVE_ALL
        li      $r0, 0x0c
        b       common_exception_handler

OS_Trap_Interrupt_HW4:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SAVE_ALL
        li      $a0, 0x0d
        b       common_exception_handler

OS_Trap_Interrupt_HW5:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SAVE_ALL
        li      $r0, 0x0e
        b       common_exception_handler

OS_Trap_SWI:
#if (VECTOR_SIZE==16)
		pop	$r0
#endif
		SAVE_ALL
        li      $r0, 0x0f
        b       common_exception_handler

/*   	.align 4
exception_handlers:
        .long   exception_handler       !Reset/NMI
        .long   exception_handler       !TLB fill
        .long   exception_handler       !PTE not present
        .long   exception_handler       !TLB misc
        .long   exception_handler       !TLB VLPT
        .long   exception_handler       !Machine Error
        .long   exception_handler       !Debug related
        .long   exception_handler       !General exception
        .long   syscall_handler         !Syscall
        .long   exception_handler       !ISR HW0
		.long   HW1_Dispatch_ISR        !ISR HW1 
        .long   exception_handler       !ISR HW2
        .long   exception_handler       !ISR HW3
        .long   exception_handler       !ISR HW4
        .long   exception_handler       !ISR HW5
        .long   SW0_ISR       		!ISR SW0
*/        

common_exception_handler:
		/*sethi   $r1, hi20(exception_handlers)
        ori     $r1, $r1, lo12(exception_handlers)
        lw      $r1, [$r1+$r0<<2]
		jral	$r1*/
		gie_disable
		RESTORE_ALL
		iret

##------------------------------------------------------------------------------
## Startup code
	.section .text
	.global	_start
	.weak   _call_exit
	.weak   _SDA_BASE_
	.weak   _FP_BASE_
	.align	2
	.func	_start
	.type	_start, @function
	
_start:
	la	$gp, _SDA_BASE_ 	! init GP for small data access
	la	$fp, _FP_BASE_		! init FP

	bal	__pre_c_init		! Call __pre_c_init()
	
   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   ! from now on, all run time address of branch and load/store target
   ! match link time address
   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
	la	$sp, _stack      	! init SP => 0x100a800
	movi	$r0, -8	  		! align SP to 8-byte
	and	$sp, $sp, $r0
1:	
   ! clear BSS, this process can be 4 time faster if data is 4 byte aligned
   ! if so, use swi.p instead of sbi.p
   
	la	$r0, __bss_start     	! get the starting addr of bss (include sbss)
	la	$r2, _end        	! get ending addr of bss (include sbss)
	beq	$r0, $r2, .L0    	! if no bss just do nothing
	movi	$r1, 0           	! should be cleared to 0
.Lclear_bss:
	swi.p	$r1, [$r0], 4   	! Clear bss
	bne	$r0, $r2, .Lclear_bss	! Still bytes left to set
.L0:
	! call main() if main() is provided
	bal	main			! load address of main

	! call _call_exit if necessary ; default implementation is in crt2.o  
	la	$r15, _call_exit	! load address of _call_exit
	beqz	$r15, 2f		! no _call_exit? go to simple exit
	jral	$r15			! _call_exit will never return
2:
	bal   _exit			! will never return 
	ret
	.size   _start, .-_start

   .end
