	.macro gie_disable
        setgie.d
        dsb
	.endm

	.macro gie_enable
        setgie.e
        dsb
	.endm

    .macro  SAVE_ALL
        pushm	$r0,$r10
		pushm	$r15,$r30
        mfsr    $r0, $PSW
        mfsr    $r1, $IPC
        mfsr    $r2, $IPSW
		pushm	$r0, $r2

	/* Descend interrupt level if necessary */
        andi    $r7, $r0, PSW_kbfINTL
        slti    $r8, $r7, 2
        bnez    $r8, 1f
        addi    $r9, $r0, -2
        mtsr    $r9, $PSW
        isb
1:
		move    $r0, $sp
		andi    $r1, $sp, #7
		bnez    $r1, 2f
		push    $r0
2:
		push    $r0
    .endm

    .macro  RESTORE_ALL
		lwi	$sp, [$sp]
        popm    $r0, $r2
        mtsr    $r0, $PSW
        mtsr    $r1, $IPC
        mtsr    $r2, $IPSW
		popm	$r15,$r30
        popm	$r0,$r10
   .endm

   .macro  SYSCALL_SAVE_ALL
        pushm	$r0,$r10
		pushm	$r15,$r30
        mfsr    $r0, $PSW
        mfsr    $r1, $IPC
		addi	$r1, $r1, 4
        mfsr    $r2, $IPSW
		pushm	$r0, $r2

	/* Descend interrupt level if necessary */
        andi    $r7, $r0, PSW_kbfINTL
        slti    $r8, $r7, 2
        bnez    $r8, 1f
        addi    $r9, $r0, -2
        mtsr    $r9, $PSW
        isb
1:
		move    $r0, $sp
		andi    $r1, $sp, #7
		bnez    $r1, 2f
		push    $r0
2:
		push    $r0
   .endm

   .macro  SYSCALL_RESTORE_ALL
		lwi	$sp, [$sp]
        popm    $r0, $r2
        mtsr    $r0, $PSW
        mtsr    $r1, $IPC
        mtsr    $r2, $IPSW
		popm	$r15,$r30
		addi	$sp, $sp, 4
        popm	$r1,$r10
   .endm
