.text

.globl	lowlevel_init
lowlevel_init:
	move	$r10, $lp
        jal     mem_init
        
        ret	$r10

!.globl mem_init
mem_init:
	move	$r9, $lp
	li	$r0, 0x90200004 /* Memory bank 0 timing parameter register */
	li	$r1, 0x00151151
	swi	$r1, [$r0]
	
	/*li	$r0, 0x90100018*/  /* AHB slave 6 Base/Size Register */
	/*li	$r1, 0x100b0000*/  /* BaseAddr (31-20), SizeAddr (19-16) */
	/*swi	$r1, [$r0]*/
	
	li	$r0, 0x98100030 /* PMU - PLL/DLL Control Register 0 - Enable DLL*/
	lwi	$r1, [$r0]
	li	$r2, 0x00010000
	or	$r1, $r1, $r2
	swi	$r1, [$r0] /* Enable DLL */
#ifdef __NDS32_N1213_43U1H__    /* AG101 */
	lwi	$r1, [$r0]
	li	$r2, 0x00e00000
	or	$r1, $r1, $r2
	swi	$r1, [$r0]
	li	$r0, 0x98100028
	lwi	$r1, [$r0]
	li	$r2, 0x00000010
	or	$r1, $r1, $r2
	swi	$r1, [$r0]
	li	$r0, 0x9810004c
	lwi	$r1, [$r0]
	li	$r2, 0x0007f000
	or	$r1, $r1, $r2
	swi	$r1, [$r0]
#endif
	li	$r0, 0x90300000 /* SDRAM Controller - Timing Parameter 1 */
	li	$r1, 0x00011312
	swi	$r1, [$r0]
	li	$r1, 0x00480180 
	swi	$r1, [$r0+0x4] /* SDRAM Timing Parameter 2 */
	li	$r1, 0x00002326 
	swi	$r1, [$r0+0x8] /* SDRAM Configuration Register 1 */
	li	$r1, 0x00000010
	swi	$r1, [$r0+0xc] /* SDRAM Configuration Register 2*/
1:
	lwi	$r1, [$r0+0xc]
	andi	$r1, $r1, 0x1c
	bnez	$r1, 1b
	
	li	$r1, 0x00000004
	swi	$r1, [$r0+0xc]
2:
	lwi	$r1, [$r0+0xc]
	bnez	$r1, 2b
	
	li	$r1, 0x00000008
	swi	$r1, [$r0+0xc]
3:
	lwi	$r1, [$r0+0xc]
	bnez	$r1, 3b

	move	$lp, $r9
	ret


