#include "config.h"

#define PSW_kbfINTL	(0x3<<1)
#define IVB_offEVIC	13      /* External Vector Interrupt Controller mode */
#define IVB_kbfEVIC	(0x1<<13)

.globl __pre_c_init
__pre_c_init:
	move $r8, $lp

	/* turn on BTB & RAS ?*/
	/* Branch Target Buffer (BTB) enabled */
	move    $r0, #0 
	mtsr    $r0, $MISC_CTL

	/*
	 * lowlevel platform initialization if no bootcode.
	 * Don't do this if there is bootcode on the platform, let bootcode do the work.
	 */
load_lli:
#if LOWLEVEL_INIT
	jal	load_lowlevel_init /* Jump to lowlevel_init */
	jral	$r0
#endif

	/* Setup $IVB */
#if (VECTOR_SIZE==4)
	movi	$r4, 0x0000
#else
	movi	$r4, 0x4000
#endif

#ifdef VIC_EVIC
	ori	$r4, $r4, IVB_kbfEVIC
#else
	bclr	$r4, $r4, IVB_offEVIC /* IVB_offEVIC = 13 */
#endif
	mtsr	$r4, $IVB /* Vector Table base = 0x0 */

	/* Set PSW INTL to 0 */
	mfsr	$r0, $psw
	li	$r1, ~PSW_kbfINTL
	and	$r0, $r0, $r1
	mtsr	$r0, $psw

	move $lp, $r8
2:
	ret

#if LOWLEVEL_INIT
load_lowlevel_init:
	la  $r6, lowlevel_init
	la  $r7, load_lli + 4
	sub $r0, $r6, $r7
	add $r0, $r0, $lp
	ret
#endif
